BEGIN {
# if ./gafrc is present, we need to load it
	local="./gafrc"
	if ((getline < local) <= 0)
		local = ""
	else
		close(local)

# load system configs and local config
	load_gafrc("/etc/gEDA/system-gafrc ~/.gEDA/gafrc " local)
}


# load gafrc files; cat the list together with the config "parser" guile script
# and run it through guile - it will print the values we are interested in, each
# config line starting with @@@. Load them in GAFRC[key, n], where:
#  - key is the name of the configuration setting
#  - n is either an integer (from 0) or "num" telling how many items there
#    are for the given key
#
function load_gafrc(fnlist     ,cmd,line,key,val,n)
{
	cmd = "cat " libdir "/gedaconf.scm " fnlist " | guile";
	close(cmd)
	while((cmd | getline line) > 0) {
		gsub("guile> ", "", line)
		if (line ~ "^@@@ ") {
			sub("^@@@ ", "", line)
			key = line
			val = line
			sub(" .*$", "", key)
			sub("^[^ ]* ", "", val)
			n = int(GAFRC[key, "num"])
			GAFRC[key, "num"]++
			GAFRC[key, n] = val
		}
	}
	if (GAFRC["gedaconf", "num"] != 1) {
		print "load_gafrc() error: failed to guile-load config." > "/dev/stderr"
		exit(1)
	}
	close(cmd)
}

