# retunrs 1 is path is absolute (from root or home)
function path_is_absolute(fn)
{
	return (fn ~ "^[/~]")
}

# returns 1 if fn exists on the file system
function path_exists(fn          , cmd, res)
{
	cmd = "ls " fn " 2>/dev/null"
	close(cmd)
	cmd | getline res
	close(cmd)
	return (res != "")
}

# check if fn exists on the file system and exits with error if not
function path_check(fn)
{
	if (!path_exists(fn)) {
		print "Error: can't find " fn > "/dev/stderr"
		exit(1)
	}
	return fn
}

# look up full path of fn from basedir, using search path from GARFC[gafrc_key, ...]
# exits with error if file not found
function path_lookup(fn, basedir, gafrc_key            ,n,v,path)
{
	if ((path_is_absolute(fn)) || (gafrc_key == ""))
		return path_check(fn);
	v = GAFRC[gafrc_key, "num"]
	for(n = 0; n < v; n++) {
		path = GAFRC[gafrc_key, n]
		if (!path_is_absolute(path)) {
			sub("^[.]/", "", path)
			if (path == ".")
				path = ""
			path = basedir "/" path
		}

		path = path "/" fn
		gsub("//*", "/", path)
#		print "$$ check " GAFRC[gafrc_key, n] " -> " path " for " fn " basedir=" basedir > "/dev/stderr"
		if (path_exists(path)) {
#			print "$$$ using " path " for " fn > "/dev/stderr"
			return path
		}
	}
	print "Error: can't find " fn " after searching " gafrc_key > "/dev/stderr"
	exit(1)
}

# prefix file name fn with prefix; if target_dir is not empty, forget
# original path found in fn and use target_dir
function path_prefix_basename(fn, prefix,    target_dir    ,dir,file)
{
	if (!(fn ~ "/"))
		return prefix fn
	file = fn
	sub("^.*/", "", file)
	if (target_dir == "") {
		target_dir = fn
		sub("/[^/]*$", "", target_dir)
	}

	file = target_dir "/" prefix file
	gsub("//*", "/", file)
	return file
}
