# load and parse a summary
# sets up global variables:
#  sym: name of the symbol used for the component
#  refdes: refdes of the component
#  ATTR[key]: component attributes
#  PIN[pinid, key]: pin attributes
#  pins: a string listing pinids
#
# when a component is fully read, user supplied callback function
# summary_got_component(sym, refdes) is invoked

BEGIN {
	sym=""
}

/^component / {
	if (sym != "")
		summary_got_component(sym, refdes)

	sym=$2
	refdes=$3
	pins=""
	delete PIN_SEEN
	delete ATTR
	next
}

/^ attr/ {
	key=$2
	$1=""
	$2=""
	val=$0
	sub("^  ", "", val)
	ATTR[key] = val
	next
}

/^ pin/ {
	pin=$2
	key=$3
	$1=""
	$2=""
	$3=""
	val=$0
	sub("^   ", "", val)
	PIN[pin, key] = val
	if (!(pin in PIN_SEEN)) {
		if (pins == "")
			pins = pin
		else
			pins = pins " " pin
		PIN_SEEN[pin]=1
	}
	next
}

END {
	if (sym != "")
		summary_got_component(sym, refdes)
}
